/*
 * WiPal - A library and a set of tools to manipulate wireless traces.
 * Copyright (C) 2008  Universite Pierre et Marie Curie - Paris 6
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 *
 * Author: Thomas Claveirole <thomas.claveirole@lip6.fr>
 */
#include <boost/preprocessor/cat.hpp>
#include <boost/preprocessor/tuple/elem.hpp>
#include <boost/preprocessor/stringize.hpp>
#include <boost/preprocessor/seq/for_each.hpp>

#include <wipal/tool/args.hh>

namespace tool
{
  namespace args
  {
    namespace internals
    {

#define WP_args_define_help_string(R, Unused, HS)		\
      const help_string						\
      BOOST_PP_CAT(help_, BOOST_PP_TUPLE_ELEM(2, 0, HS))	\
	(BOOST_PP_STRINGIZE(BOOST_PP_TUPLE_ELEM(2, 0, HS)),	\
	 BOOST_PP_TUPLE_ELEM(2, 1, HS));

      BOOST_PP_SEQ_FOR_EACH(WP_args_define_help_string, ~, WP_ARGS_OPTIONS)

#undef WP_args_define_help_string

    } // End of namespace tool::args::internals.

  } // End of namespace tool::args.

} // End of namespace tool.
