#! /usr/bin/env python

import sys
import scapy

msgs            = ['Destination addresses', 'Source addresses', 'SSID\'s']
Dst             = 0
Src             = 1
SSID            = 2

pr_req_mac_freq = [{} for i in range(3)]
error_count = 0

def new_frame(f):

    if f.noise:
        global error_count

        error_count += 1
        return

    p = f.payload
    if p.type == 0 and p.subtype == 4:
        addr = [p.addr1, p.addr2, p.addr3]

        for i in [Dst, Src, SSID]:
            if addr[i] not in pr_req_mac_freq[i]:
                pr_req_mac_freq[i][addr[i]] = 0
            pr_req_mac_freq[i][addr[i]] += 1

scapy.sniff(offline='chihuahuan-ath2', count=int (sys.argv[1]), prn=new_frame)

sys.stdout.write('Frames with PHY errors: %d\n' % error_count)
sys.stdout.write('* Probe Requests:\n')

for i in range(3):
    sys.stdout.write('  - %s:\n' % msgs[i])
    for addr in pr_req_mac_freq[i]:
        sys.stdout.write('    %s\t%d\n' % (addr, pr_req_mac_freq[i][addr]))

